function [FIG,FIG_ENG,battANALOG,ATTIVA] = report_PT100(rPT100,m,NodoPT100Link,...
    toolrif,unitrif,datarif,Font_caption,Font_tools,siteID,DT,DT_ENG,FIG,FIG_ENG,...
    battANALOG,ATTIVA,activeEN,contunit,br,status,conn,FileName)

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'report_PT100 function started';
fprintf(fileID,fmt,text);

import mlreportgen.dom.*
import mlreportgen.report.*

% Make sure DOM is compilable
makeDOMCompilable()

if status(m,1) == 1
    if ATTIVA == 1
        ATTIVA = 0;
        testo = Paragraph('GMUX non ancora installato o canale inattivo.');
        add(DT,testo);
        if activeEN == 1
            testo = Paragraph('GMUX not installed or inactive.');
            add(DT_ENG,testo);
        end
    end
elseif status(m,1) == 3
    if ATTIVA == 1
        ATTIVA = 0;
        testo = Paragraph(['Monitoraggio completato. Invitiamo a visitare la '...
            'piattaforma web per la visione dei dati storici.']);
        add(DT,testo);
        if activeEN == 1
            testo = Paragraph(['Monitoring completed. Please log into the web-based platform '...
                'to access the complete dataset.']);
            add(DT_ENG,testo);
        end
    end
else
    PTE = Section();
    titolo = 1;
    
    if battANALOG == 0
        comando = ['select Date, Time, UnitName, ToolNameID, BatLevel, Temperature from RawDataView where Date >= ''' ...
            datarif ''' and UnitName = ''' char(unitrif) ''' and ToolNameID = '''...
            char(toolrif) ''' and NodeNum = 1 '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        BatTemp = curs.Data;
        [~,cc] = size(BatTemp);
        if cc ~= 1 %ci sono dati riferiti all'ultimo mese/periodo di interesse
            DataPlot = [BatTemp(:,1) BatTemp(:,2)];
            % sistemo date, batteria e temperatura
            [rD,~] = size(DataPlot);
            T = [cell2mat(DataPlot(:,1)) repmat(' ', [rD,1]) cell2mat(DataPlot(:,2))];
            Date = datenum(T);
            Batteria = cell2mat(BatTemp(:,5));
            Temperatura = cell2mat(BatTemp(:,6));
            
            % testo introduttivo
            testoB1 = Paragraph(['I valori di tensione di alimentazione del GMUX durante il periodo '...
                'di monitoraggio sono riportati di seguito. Il corretto funzionamento del sistema '...
                char(232) ' assicurato per una carica superiore a 12 V. L''ultimo dato disponibile ' char(232) ' pari '...
                'a ' num2str(Batteria(end,1)) ' V.']);
            testoB2 = Paragraph(['Il GMUX integra al proprio interno un termometro '...
                'per monitorate la temperatura di esercizio ed identificare eventuali '...
                'anomalie. I dati di temperatura registrati sono riportati di seguito.']);
            testoB1.HAlign = 'justify';
            testoB2.HAlign = 'justify';
            
            % grafico batteria
            figure(19)
            plot(Date,Batteria);
            hold on
            title('Batteria e Temperatura del GMUX');
            xlabel('Data [gg/mm/aaaa]');
            ylabel('Livello di Batteria [V]');
            ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
            
            yyaxis right
            GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
            ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
            ylabel(['Temperatura [' char(176) 'C]']);
            set(gca,'YColor','k');
            str(1,1) = cellstr('Batteria');
            str(2,1) = cellstr('Temperatura');
            legend(str,'Location','northwest');
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            xlim([Date(1)-1 Date(end)+1]);
                        
            TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX.png'));
            saveas(GMUX,TempName);
            ChartGMUX = Image(TempName);
            ChartGMUX.Style = {Height('8cm'),HAlign('center')};
            if Batteria(end,1) >= 12.5
                TempName = char(strcat('B_13.jpg'));
            elseif Batteria(end,1) >= 12
                TempName = char(strcat('B_12.jpg'));
            elseif Batteria(end,1) >= 11.3
                TempName = char(strcat('B_115.jpg'));
            elseif Batteria(end,1) >= 10.5
                TempName = char(strcat('B_11.jpg'));
            else
                TempName = char(strcat('B_10.jpg'));
            end
            Batt = Image(TempName);
            Batt.Style = {Height('4cm'),HAlign('center')};
           
            lot = Table({ChartGMUX, Batt});
            lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
            lot.Style = {ResizeToFitContents(false),Width("100%")};
            grps(1) = TableColSpecGroup;
            grps(1).Span = 2;
            specs(1) = TableColSpec;
            specs(1).Span = 1;
            specs(1).Style = {Width("80%")};
            specs(2) = TableColSpec;
            specs(2).Span = 1;
            specs(2).Style = {Width("20%")};
            grps(1).ColSpecs = specs;
            lot.ColSpecGroups = grps;
            
            lot_cap = Paragraph(['Fig. ' num2str(FIG) ' - Livello di carica della batteria e temperatura del '...
                'GMUX durante il periodo di riferimento']);
            FIG = FIG+1;
            lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            FIG = FIG+1;
            Chart_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            sezBATT = Paragraph('GMUX - Batteria e Temperatura');
            sezBATT.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
            add(DT,sezBATT);
            add(DT,testoB1);
            add(DT,testoB2);
            add(DT,lot);
            add(DT,lot_cap);
            add(DT,br);
            close(figure(19));
            
            if activeEN == 1
                testoB1 = Paragraph(['The following chart reports the GMUX battery level trend recorded '...
                    'during the reference time period. '...
                    'The correct functioning of the data acquisition system is guaranteed for a '...
                    'minimum level of 12 V. The last available data is equal to ' num2str(Batteria(end,1)) ' V.']);
                testoB2 = Paragraph(['GMUX equips also a thermometer that allows the monitoring '...
                    'of the working temperature and the identification of eventual malfunctioning. The same '...
                    'chart displays also temperature data recorded by the multiplexer.']);
                testoB1.HAlign = 'justify';
                testoB2.HAlign = 'justify';
                
                % grafico batteria
                figure(19)
                plot(Date,Batteria);
                hold on
                title('GMUX battery level and temperature');
                xlabel('Date [dd/mm/yyyy]');
                ylabel('Battery Level [V]');
                ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
                
                yyaxis right
                GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
                ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
                ylabel(['Temperature [' char(176) 'C]']);
                set(gca,'YColor','k');
                str(1,1) = cellstr('Battery');
                str(2,1) = cellstr('Temperature');
                legend(str,'Location','northwest');
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                xlim([Date(1)-1 Date(end)+1]);
                
                TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX_ENG.png'));
                saveas(GMUX,TempName);
                ChartGMUX = Image(TempName);
                ChartGMUX.Style = {Height('8cm'),HAlign('center')};
                Batt = Image(TempNameB);
                Batt.Style = {Height('4cm'),HAlign('center')};
                
                lot = Table({ChartGMUX, Batt});
                lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
                lot.Style = {ResizeToFitContents(false),Width("100%")};
                grps(1) = TableColSpecGroup;
                grps(1).Span = 2;
                specs(1) = TableColSpec;
                specs(1).Span = 1;
                specs(1).Style = {Width("80%")};
                specs(2) = TableColSpec;
                specs(2).Span = 1;
                specs(2).Style = {Width("20%")};
                grps(1).ColSpecs = specs;
                lot.ColSpecGroups = grps;
                
                lot_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Battery level and temperature recorded '...
                    'by the GMUX during the reference time period']);
                FIG_ENG = FIG_ENG+1;
                lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                Batt_ENG = Section();
                sezBATT_ENG = Heading3('GMUX - Battery and temperature');
                sezBATT_ENG.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
                Batt_ENG.Title = sezBATT_ENG;
                add(DT_ENG,sezBATT_ENG);
                add(DT_ENG,testoB1);
                add(DT_ENG,testoB2);
                add(DT_ENG,lot);
                add(DT_ENG,lot_cap);
                add(DT_ENG,br);
                close(figure(19));
            end
                
            battANALOG = 1;
        end
    end
    
    for n = 1:rPT100(m,1)
        NodeNum = num2str(NodoPT100Link(n,m));
        comando = ['select EventDate, EventTime, T_node from ElabDataView where EventDate >= ''' ...
            datarif ''' and  ToolNameID = ''' char(toolrif) ''' and UnitName = ''' char(unitrif) ...
            ''' and NodeNum = ''' NodeNum ''' '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        Dati = curs.Data;
        % Modifico il formato di data e ora
        [rD,rC] = size(Dati);
        if rC ~= 1
            T = [cell2mat(Dati(:,1)) repmat(' ', [rD,1]) cell2mat(Dati(:,2))];
            Date = datenum(T); % Data
            TempPT100 = cell2mat(Dati(:,3)); % temperatura
            MaxTempPT100 = max(TempPT100);
            MinTempPT100 = min(TempPT100);
            
            % grafico temperatura
            figure(1)
            graficoPT100 = plot(Date,TempPT100);
            xlim([Date(1)-1 Date(end)+1]);
            title(['Andamento della temperatura registrata dal sensore numero ' NodeNum ]);
            xlabel('Data [gg/mm/aaaa]');
            ylabel(['Temperatura [' char(176) 'C]']);
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            
            TempName = char(strcat('Report',siteID,'-', char(toolrif),'PT100_',NodeNum,'.png'));
            if titolo == 1
                sezPT100 = Heading3('PT100 Link');
                sezPT100.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                PTE.Title = sezPT100;
                add(DT,sezPT100);
                if activeEN == 0
                    titolo = 0;
                end
            end
            
            saveas(graficoPT100,TempName);
            ChartPT100 = Image(TempName);
            ChartPT100.Style = {Height('7.3cm'),HAlign('center')};
            ChartPT100_cap = Paragraph(['Fig. ' num2str(FIG) ' - Andamento della'...
                ' temperatura misurata dalla sonda PT100 numero ' NodeNum...
                ' durante il periodo temporale di riferimento']);
            FIG = FIG+1;
            ChartPT100_cap.Style = {HAlign('justify'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            
            testo = Paragraph(['I grafici seguenti mostrano i valori di temperatura '...
                'misurati dalle sonde PT100 collegato all''Analog Array.']);
            testo2 = Paragraph(['Durante il periodo temporale di riferimento, il nodo '...
                'numero ' NodeNum ' ha registrato valori massimi e minimi di temperatura rispettivamente pari '...
                'a ' num2str(MaxTempPT100,'%0.1f') '' char(176) 'C e ' num2str(MinTempPT100,'%0.1f') '' char(176) 'C.']);
            testo.HAlign = 'justify';
            if n == 1
                add(DT,testo);
            end
            add(DT,testo2);
            add(DT,ChartPT100);
            add(DT,ChartPT100_cap);
            if n == rPT100(m,1)
                add(DT,br);
            end
            close(figure(1));
            
            if activeEN == 1
                % grafico temperatura
                figure(1)
                graficoPT100 = plot(Date,TempPT100);
                xlim([Date(1)-1 Date(end)+1]);
                title(['Temperature recorded by sensor no. ' NodeNum ]);
                xlabel('Date [dd/mm/yyyy]');
                ylabel(['Temperature [' char(176) 'C]']);
                h = gca;
                h.XAxis.MinorTick = 'on';
                datetick('x','dd/mm/yyyy','keepticks','keeplimits');
                xtickangle(20);
                grid on
                grid minor
                
                TempName = char(strcat('Report',siteID,'-', char(toolrif),'PT100_',NodeNum,'_ENG.png'));
                if titolo == 1
                    sezPT100 = Heading3('PT100 Link');
                    sezPT100.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                    PTE.Title = sezPT100;
                    add(DT,sezPT100);
                    titolo = 0;
                end
                
                saveas(graficoPT100,TempName);
                ChartPT100 = Image(TempName);
                ChartPT100.Style = {Height('7.3cm'),HAlign('center')};
                ChartPT100_cap = Paragraph(['Fig. ' num2str(FIG_ENG) ' - Time evolution of '...
                    ' the temperature recorded by PT100 sensor number ' NodeNum...
                    ' during the reference time period']);
                FIG_ENG = FIG_ENG+1;
                ChartPT100_cap.Style = {HAlign('justify'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
                
                testo = Paragraph(['The following graphs show the temperature values '...
                    'recorded by PT100 sensors.']);
                testo2 = Paragraph(['During the reference time period, node number '...
                    NodeNum ' highlighted maximum and minimum temperature values equal to '...
                    num2str(MaxTempPT100,'%0.1f') '' char(176) 'C and ' num2str(MinTempPT100,'%0.1f') '' char(176) 'C respectively.']);
                testo.HAlign = 'justify';
                if n == 1
                    add(DT_ENG,testo);
                end
                add(DT_ENG,testo2);
                add(DT_ENG,ChartPT100);
                add(DT_ENG,ChartPT100_cap);
                if n == rPT100(m,1)
                    add(DT_ENG,br);
                end
                close(figure(1));
            end
            %pulisco variabili da riutilizzare per catena successiva
            clear TempPT100;
            clear MaxTempPT100;
            clear MinTempPT100;
        else
            if ATTIVA == 1
                ATTIVA = 0;
                testo = Paragraph('Non sono presenti dati relativi al periodo temporale considerato.');
                add(DT,testo);
                if activeEN == 1
                    testo = Paragraph('No data available for the reference time period.');
                    add(DT_ENG,testo);
                    if m == 1
                        add(DT_ENG,br);
                    end
                end
            end
        end
    end
end

text = 'report_PT100 function executed correctly';
fprintf(fileID,fmt,text);
fclose(fileID);

end